; 
    include \masm32\include\masm32rt.inc
    include \masm32\macros\timers.asm

    .686

    lstrlenA PROTO:DWORD
    AzmtStrLen1A PROTO:DWORD
    AzmtStrLen2A PROTO:DWORD

    markl_szlen PROTO:DWORD

; 
    .data
      szTest byte "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl",\
                  0,0,0,0
    .code
; 
start:
; 

    invoke lstrlenA, ADDR szTest
    push  eax
    print "lstrlenA return value     : "
    pop   eax
    print ustr$(eax),13,10

    invoke AzmtStrLen1A, ADDR szTest
    push  eax
    print "AzmtStrLen1A return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke AzmtStrLen2A, ADDR szTest
    push  eax
    print "AzmtStrLen2A return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke markl_szlen, ADDR szTest
    push  eax
    print "markl_szlen return value  : "
    pop   eax
    print ustr$(eax),13,10,13,10

    LOOP_COUNT equ 1000000
    invoke Sleep, 3000

    print "lstrlenA      : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke lstrlenA, ADDR szTest
    counter_end
    print ustr$(eax)," cycles",13,10

    print "AzmtStrLen1A  : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke AzmtStrLen1A, ADDR szTest
    counter_end
    print ustr$(eax)," cycles",13,10

    print "AzmtStrLen2A  : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke AzmtStrLen2A, ADDR szTest
    counter_end
    print ustr$(eax)," cycles",13,10

    print "markl_szlen   : "
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke markl_szlen, ADDR szTest
    counter_end
    print ustr$(eax)," cycles",13,10,13,10

    inkey "Press any key to exit..."
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

;
; Returns the string length in EAX and pointer in EDX.
;
; p_lpszStr : Pointer to the string.
;
AzmtStrLen1A PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax

@@:
    mov ecx, dword ptr [edx+eax]
    add eax, 16
    test ecx, 0FFh
    jz @0
    test ecx, 0FF00h
    jz @1
    test ecx, 0FF0000h
    jz @2
    test ecx, 0FF000000h
    jz @3
    mov ecx, dword ptr [edx+eax-12]
    test ecx, 0FFh
    jz @4
    test ecx, 0FF00h
    jz @5
    test ecx, 0FF0000h
    jz @6
    test ecx, 0FF000000h
    jz @7
    mov ecx, dword ptr [edx+eax-8]
    test ecx, 0FFh
    jz @8
    test ecx, 0FF00h
    jz @9
    test ecx, 0FF0000h
    jz @10
    test ecx, 0FF000000h
    jz @11
    mov ecx, dword ptr [edx+eax-4]
    test cl, cl
    jz @12
    test ecx, 0FF00h
    jz @13
    test ecx, 0FF0000h
    jz @14
    test ecx, 0FF000000h
    jnz @B

    sub eax, 1
    ret 4

@0:
    sub eax, 16
    ret 4

@1:
    sub eax, 15
    ret 4

@2:
    sub eax, 14
    ret 4

@3:
    sub eax, 13
    ret 4

@4:
    sub eax, 12
    ret 4

@5:
    sub eax, 11
    ret 4

@6:
    sub eax, 10
    ret 4

@7:
    sub eax, 9
    ret 4

@8:
    sub eax, 8
    ret 4

@9:
    sub eax, 7
    ret 4

@10:
    sub eax, 6
    ret 4

@11:
    sub eax, 5
    ret 4

@12:
    sub eax, 4
    ret 4

@13:
    sub eax, 3
    ret 4

@14:
    sub eax, 2
    ret 4

AzmtStrLen1A ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

;
; Returns the string length in EAX and pointer in EDX.
;
; p_lpszStr : Pointer to the string.
;
AzmtStrLen2A PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax

@@:
    mov ecx, dword ptr [edx+eax]
    add eax, 16
    test cl, cl
    jz @0
    test ch, ch
    jz @1
    test ecx, 0FF0000h
    jz @2
    test ecx, 0FF000000h
    jz @3
    mov ecx, dword ptr [edx+eax-12]
    test cl, cl
    jz @4
    test ch, ch
    jz @5
    test ecx, 0FF0000h
    jz @6
    test ecx, 0FF000000h
    jz @7
    mov ecx, dword ptr [edx+eax-8]
    test cl, cl
    jz @8
    test ch, ch
    jz @9
    test ecx, 0FF0000h
    jz @10
    test ecx, 0FF000000h
    jz @11
    mov ecx, dword ptr [edx+eax-4]
    test cl, cl
    jz @12
    test ch, ch
    jz @13
    test ecx, 0FF0000h
    jz @14
    test ecx, 0FF000000h
    jnz @B

    sub eax, 1
    ret 4

@0:
    sub eax, 16
    ret 4

@1:
    sub eax, 15
    ret 4

@2:
    sub eax, 14
    ret 4

@3:
    sub eax, 13
    ret 4

@4:
    sub eax, 12
    ret 4

@5:
    sub eax, 11
    ret 4

@6:
    sub eax, 10
    ret 4

@7:
    sub eax, 9
    ret 4

@8:
    sub eax, 8
    ret 4

@9:
    sub eax, 7
    ret 4

@10:
    sub eax, 6
    ret 4

@11:
    sub eax, 5
    ret 4

@12:
    sub eax, 4
    ret 4

@13:
    sub eax, 3
    ret 4

@14:
    sub eax, 2
    ret 4

AzmtStrLen2A ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

markl_szlen proc pString:DWORD

    push ebx
    push esi

    mov esi, [esp+12]

    ;------------------------------------------
    ; Special handling for zero-length string.
    ;------------------------------------------

    mov eax, [esi]
    or  eax, eax
    jz  fini
  @@:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov ecx, [esi+8]
    mov edx, [esi+12]
    add esi, 16
    and eax, 0ff000000h
    jz  dw0
    and ebx, 0ff000000h
    jz  dw1
    and ecx, 0ff000000h
    jz  dw2
    and edx, 0ff000000h
    jz  dw3
    jmp @B
 dw0:
    sub esi, 4
 dw1:
    sub esi, 4
 dw2:
    sub esi, 4
 dw3:
    sub esi, 4
    cmp BYTE PTR [esi],0
    je  @F
    inc esi
    jmp @B
 @@:   
    sub esi, [esp+12]
    mov eax, esi
 fini:
    pop esi
    pop ebx

    ret 4

markl_szlen endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start

